
GO
PRINT N'Modificando [dbo].[DeleteUtterance]...';


GO
ALTER PROCEDURE [dbo].[DeleteUtterance] (
	@VCC			VARCHAR(50) = NULL,
	@AppId			VARCHAR(50) = NULL,
	@IntentId		VARCHAR(50) = NULL,
	@Id				VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON
    -- DECLARE @ENGINE VARCHAR(15)  = (SELECT [CognitiveEngine] FROM [dbo].[VCC] (NOLOCK) WHERE [VCC] = @VCC)
	-- DECLARE @ID     VARCHAR(50) = @UtteranceId
	-- DECLARE @TempId VARCHAR(50) = NULL
	
	DELETE [Utterance] 
		WHERE [VCC] = @VCC
			AND [AppId] = @AppId
			AND [IntentId] = @IntentId
			AND [Id] = @Id
	
	DELETE [UtteranceEntity] 
		WHERE [VCC] = @VCC
			AND [UtteranceId] = @Id
			
			
	DELETE FROM [dbo].[Underlined] WHERE [VCC] = @VCC AND [UtteranceId] = @Id

    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveNLU]...';


GO

ALTER PROCEDURE [dbo].[SaveNLU] (
	@VCC Varchar(50) = NULL, 					
	@Name Varchar(50) = NULL,					
	@Culture Varchar(50) = NULL,
	@Description Varchar(50) = NULL,			
	@AppId Varchar(100) = NULL,					
	@SubscriptionKey Varchar(50) = NULL,
	@IsSystemApp BIT = 0,
	@IsPublished BIT = NULL,
	@LastPublishedDate DATETIME = NULL,
	@IsTrained BIT = NULL,
	@NeedTrain BIT = NULL,
	@LastTrainedDate DATETIME = NULL,
	@CreatedDate Datetime = NULL,               
	@CreatedByUserId Varchar(50) = NULL,		
	@LastModifiedDate Datetime = NULL,			
	@LastModifiedByUserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	-- SI LA VARIABLE LLEGA NULL, LA SETTEAMOS COMO 0
	IF @IsSystemApp IS NULL 
		SET @IsSystemApp = 0

	UPDATE [NLU]
	SET [Culture] = @Culture,
		[Description] = @Description,
		[AppId] = @AppId,
		[IsPublished] = CASE WHEN @IsPublished IS NULL THEN [IsPublished] ELSE @IsPublished END,
		[LastPublishedDate] = @LastPublishedDate,
		[IsSystemApp] = CASE WHEN @IsSystemApp IS NULL THEN [IsSystemApp] ELSE @IsSystemApp END,
		[SubscriptionKey] = CASE WHEN @SubscriptionKey IS NULL THEN [SubscriptionKey] ELSE @SubscriptionKey END,
		[IsTrained] = CASE WHEN @IsTrained IS NULL THEN [IsTrained] ELSE @IsTrained END,
		[NeedTrain] = CASE WHEN @NeedTrain IS NULL THEN [NeedTrain] ELSE @NeedTrain END,
		[LastTrainedDate] = CASE WHEN @LastTrainedDate IS NULL THEN [LastTrainedDate] ELSE @LastTrainedDate END,
		-- [CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
    AND [Name] = @Name

    IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [NLU] (
			[VCC], [Name], [Culture],
			[Description], [AppId], [SubscriptionKey],
			[IsSystemApp], [CreatedDate], [CreatedByUserId], 
			[LastModifiedDate], [LastModifiedByUserId], [TimeStamp],[CognitiveEngine]
			)
		VALUES (
			@VCC, @Name, @Culture,
			@Description, @AppId, @SubscriptionKey,
			@IsSystemApp, GETUTCDATE(), @CreatedByUserId, 
			@LastModifiedDate, @LastModifiedByUserId, GETUTCDATE(),
			IIF(@IsSystemApp = 1, 'RASA', (SELECT [CognitiveEngine] FROM [dbo].[VCC] WHERE [VCC] = @VCC))
		)
	END
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveUnderlined]...';


GO
-- [dbo].[SaveUtterance] 'allegro', '4bad9174-ea84-45ee-ab2f-b17c73c43734', '45799dd8-17e7-49a1-9bd8-cb74f00a788c', '{f2c9e160-8eeb-11e9-8562-b65bb2fb6bcb}', 0, 1, 'in', 10, 14, 1.23, 1.38, 0, 'hola', '2019-08-02 15:30:00.000', 'analytic', NULL, NULL
ALTER PROCEDURE [dbo].[SaveUnderlined]
(
	@VCC						VARCHAR(50),
	@AppId						VARCHAR(50),
	@IntentId					VARCHAR(50),
	@AudioId					VARCHAR(50),
	@Section					NUMERIC(5, 0),
	@Part						NUMERIC(5, 0),
	@Speaker					VARCHAR(3),
	@AnchorOffset				INT,
	@FocusOffset				INT,
	@CurrentTime				FLOAT,
	@EndCurrentTime				FLOAT,
	@UtteranceId				VARCHAR(50),
	@TextContent				VARCHAR(500),
	@CreatedDate				DATETIME,
	@CreatedByUserId			VARCHAR(50),
	@LastModifiedDate			DATETIME,
	@LastModifiedByUserId		VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	-- EN CASO LLEGUE COMO NULL LO IGUALAMOS A 0
	IF @Section IS NULL BEGIN SET @Section = 0 END 

	UPDATE [dbo].Underlined SET
		[VCC] = @VCC,
		[AudioId] = @AudioId,
		[Section] = @Section,
		[Part] = @Part,
		[Speaker] = @Speaker,
		[AnchorOffset] = @AnchorOffset,
		[FocusOffset] = @FocusOffset,
		[CurrentTime] = @CurrentTime,
		[EndCurrentTime] = @EndCurrentTime,
		[UtteranceId] = @UtteranceId,
		[CreatedDate] = @CreatedDate,
		[CreatedByUserId] = @CreatedByUserId,
		[LastModifiedDate] = @LastModifiedDate,
		[LastModifiedByUserId] = @LastModifiedByUserId,
		[TimeStamp] = GETUTCDATE()
	WHERE
		[VCC] = @VCC
	    AND [UtteranceId] = @UtteranceId
		AND [AudioId] = @AudioId
		AND [Section] = @Section
		AND [Part] = @Part

	IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [dbo].[Underlined] (
			[VCC],
			[AudioId],
			[Section],
			[Part],
			[Speaker],
			[AnchorOffset],
			[FocusOffset],
			[CurrentTime],
			[EndCurrentTime],
			[UtteranceId],
			[CreatedDate],
			[CreatedByUserId],
			[LastModifiedDate],
			[LastModifiedByUserId],
			[TimeStamp]
		)
		VALUES(
			@VCC,
			@AudioId,
			@Section,
			@Part,
			@Speaker,
			@AnchorOffset,
			@FocusOffset,
			@CurrentTime,
			@EndCurrentTime,
			@UtteranceId,
			@CreatedDate,
			@CreatedByUserId,
			@LastModifiedDate,
			@LastModifiedByUserId,
			GETUTCDATE()
		)
	END

	SELECT 1 AS 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Actualización completada.';


GO
