-- ARCHIVO CON LAS ACTUALIZACIONES DE DATA DE SQL PARA MIGRAR AL NUEVO BUILD DEL NOMBRE DE LA CARPETA
-- DECLARAMOS DOS VARIABLES, UNA CON LA VERSION DE LA QUE PARTIMOS Y OTRA CON LA NUEVA VERSION QUE ESTAMOS APUNTANDO
DECLARE @OLD_DATABASE_BUILD_VERSION VARCHAR(50) = '1.12.1'
DECLARE @NEW_DATABASE_BUILD_VERSION VARCHAR(50) = '2.0.0'

-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
BEGIN TRY
    -- VALIDAMOS QUE LA VERSION EXISTENTE COINCIDE CON NUESTRA NEW_DATABASE_BUILD_VERSION
    IF NOT EXISTS (
        SELECT 1 
            FROM [dbo].[Version] V 
            WHERE V.[BuildVersion] = @OLD_DATABASE_BUILD_VERSION
    )	
        -- LANZAMOS UN MENSAJE DE ERROR INDICANDO QUE LA VERSION ACTUAL NO COINCIDE CON LA OLD_DATABASE_BUILD_VERSION
        RAISERROR('DATABASE_ERROR_INCORRECT_TARGET_VERSION', 16, 16)
        
    -- INICIAMOS LA TRANSACCION
    BEGIN TRANSACTION




    -- AQUI EMPIEZA LA SECCION CON LOS INSERT/UPDATE/DELETE PARA LA NUEVA VERSION



    -- INSERTAMOS EL AMBIENTE I6 PARA EL VCC SYSTEM
    INSERT [dbo].[Environment] ([VCC], [Name], [Type], [Description], [ApiHost], [ApiPort], [ApiUser], [ApiPassword], [DbDisabled], [DbServer], [DbPort], [DbUser], [DbPassword], [PbxDisabled], [PbxServer], [PbxPort], [PbxUser], [PbxPassword], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]) VALUES (N'system', N'AmbienteI6', N'i6', N'AmbienteI6', N'', N'', N'', N'', 0, N'', N'', N'', N'', NULL, NULL, NULL, NULL, NULL, CAST(N'2018-06-27T23:08:11.947' AS DateTime), N'analytic', GETUTCDATE(), N'analytic', GETUTCDATE())

    -- REMOVEMOS EL AMBIENTE ALLEGRO DE LOS VCC I6 Y AGREGAMOS EL AMBIENTE I6
    UPDATE E
        SET E.[Type] = 'i6'
        FROM [dbo].[Environment] E
        INNER JOIN [dbo].[VCC] V 
            ON V.[VCC] = E.[VCC]
        WHERE V.[Type] = 'I6'

    -- ACTUALIZAMOS LA TABLA AUDIO
    UPDATE [dbo].[Audio] SET [NeedI6Update] = 0


    -- AQUI TERMINA LA SECCION CON LOS INSERT/UPDATE/DELETE PARA LA NUEVA VERSION


    

    -- TERMINAMOS LA ACTUALIZACION DE DATA ACTUALIZANDO EL BUILDVERSION
    UPDATE [dbo].[Version] 
        SET [BuildVersion] = @NEW_DATABASE_BUILD_VERSION, 
            [IsRegistered] = 0,
            [TimeStamp] = GETUTCDATE() 
        WHERE [BuildVersion] = @OLD_DATABASE_BUILD_VERSION
    PRINT 'UPDATED_DATABASE_BUILD_VERSION'

    -- COMPLETAMOS LA TRANSACCION
    COMMIT TRANSACTION
END TRY
BEGIN CATCH
    IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

    DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
    DECLARE @Severity integer = ERROR_SEVERITY()
    DECLARE @State integer = ERROR_STATE()

    RAISERROR(@Message, @Severity, @State)
    --RETURN -1
END CATCH



